team join players @s[tag=!init]
gamemode adventure @s[tag=!init]

tag @s[tag=!init] add unspeed

attribute @s[tag=!unspeed] minecraft:generic.movement_speed modifier remove 1-1-1-1-1
attribute @s[tag=!unspeed] minecraft:generic.movement_speed modifier add 1-1-1-1-1 speed 0.17 multiply
tag @s[tag=!unspeed] add unspeed

clear @s bucket

effect give @s minecraft:resistance 5 4 true
effect give @s[tag=night] minecraft:night_vision 20 0 true
effect clear @s[tag=!night] minecraft:night_vision

attribute @s[tag=!init] minecraft:generic.movement_speed modifier add 1-1-1-1-1 speed 0.17 multiply

attribute @s[tag=!init] minecraft:generic.knockback_resistance base set 10

data modify storage cod:inventory Inventory set from entity @s Inventory
data modify storage cod:inventory Pile set from storage cod:inventory Inventory

data remove storage cod:inventory Pile[{Slot:0b}]
data remove storage cod:inventory Pile[{Slot:1b}]
data remove storage cod:inventory Pile[{Slot:2b}]
data remove storage cod:inventory Pile[{Slot:3b}]
data remove storage cod:inventory Pile[{Slot:4b}]
data remove storage cod:inventory Pile[{Slot:5b}]
data remove storage cod:inventory Pile[{Slot:6b}]
data remove storage cod:inventory Pile[{Slot:7b}]
data remove storage cod:inventory Pile[{Slot:8b}]

execute if score #puzzle global matches 1.. if entity @s[gamemode=adventure] unless data storage cod:inventory Pile[26] run function cod:pre_drop
execute unless score #puzzle global matches 1.. if entity @s[gamemode=adventure] unless data storage cod:inventory Pile[23] run function cod:pre_drop

data remove storage cod:inventory Pile[{tag:{inv:1b}}]

execute if entity @s[gamemode=adventure] if data storage cod:inventory Pile[0] run function cod:pre_drop

execute if entity @s[gamemode=adventure] if score #puzzle global matches 1.. unless data storage cod:inventory Inventory[{Slot:9b,tag:{exit:1b}}] if data storage cod:inventory Inventory[0] run function cod:exit
execute if entity @s[gamemode=adventure] unless score #puzzle global matches 1.. unless score #cooldown global matches 15.. unless data storage cod:inventory Inventory[{Slot:9b,tag:{progress:1b}}] if data storage cod:inventory Inventory[0] run function cod:progress
execute if entity @s[gamemode=adventure] if score #puzzle global matches 1.. unless data storage cod:inventory Inventory[{Slot:11b,tag:{save:1b}}] if data storage cod:inventory Inventory[0] run function cod:save
execute if entity @s[gamemode=adventure] if score #puzzle global matches 1.. unless data storage cod:inventory Inventory[{Slot:13b,tag:{restart:1b}}] if data storage cod:inventory Inventory[0] run function cod:restart
execute if entity @s[gamemode=adventure] if score #puzzle global matches 1.. unless data storage cod:inventory Inventory[{Slot:15b,tag:{load:1b}}] if data storage cod:inventory Inventory[0] run function cod:load_save
execute if entity @s[gamemode=adventure] unless data storage cod:inventory Inventory[{Slot:17b,tag:{night:1b}}] if data storage cod:inventory Inventory[0] run function cod:night

execute if score #puzzle global matches 1.. run item replace entity @s[gamemode=adventure] inventory.0 with feather{display:{Name:'{"text":"Exit","color":"red","italic":false}'},inv:1b,exit:1b} 1
execute unless score #puzzle global matches 1.. run item replace entity @s[gamemode=adventure] inventory.0 with compass{display:{Name:'{"text":"Progress","color":"gold","italic":false}'},inv:1b,progress:1b} 1
execute if score #puzzle global matches 1.. run item replace entity @s[gamemode=adventure] inventory.2 with clock{display:{Name:'{"text":"Save","color":"gold","italic":false}'},inv:1b,save:1b} 1
execute if score #puzzle global matches 1.. run item replace entity @s[gamemode=adventure] inventory.4 with skeleton_skull{display:{Name:'{"text":"Restart","color":"gold","italic":false}'},inv:1b,restart:1b} 1
execute if score #puzzle global matches 1.. run item replace entity @s[gamemode=adventure] inventory.6 with ender_eye{display:{Name:'{"text":"Load","color":"gold","italic":false}'},inv:1b,load:1b} 1
item replace entity @s[gamemode=adventure] inventory.8 with spyglass{display:{Name:'{"text":"Toggle Night Vision","color":"green","italic":false}'},inv:1b,night:1b} 1

title @s[gamemode=survival] actionbar {"text":"Mechanics will not function in survival mode.","color":"red"}

execute unless score #cooldown global matches 1.. unless score #puzzle global matches 1.. if entity @s[gamemode=adventure] if predicate cod:sneaking if block ~ ~-2 ~ minecraft:structure_block if entity @s[nbt={OnGround:1b}] run function cod:start

execute at @s if score #puzzle global matches 1.. if block ~ ~ ~ #cod:solid run tag @s[gamemode=adventure] add squish
execute at @s if entity @s[gamemode=adventure] if score #puzzle global matches 1.. if block ~ ~ ~ piston_head run function cod:piston_head

execute unless score #puzzle global matches 1.. unless score #win global matches 1.. if block ~ ~ ~ minecraft:light_weighted_pressure_plate[power=1] if block ~ ~-2 ~ minecraft:netherite_block run function cod:win
execute unless score #puzzle global matches 1.. unless score #completion global matches 1.. if block ~ ~ ~ minecraft:crimson_pressure_plate[powered=true] if block ~ ~-2 ~ minecraft:netherite_block run function cod:completion

execute if entity @s[tag=limbo] at @e[limit=1,tag=spawn] run function cod:limbo

execute if entity @s[tag=squish] run function cod:squish

execute unless predicate cod:sneaking run scoreboard players remove #clang global 1

execute if score #start global matches 1.. run tag @s[tag=!init] add init